// 12.1 - wait, notifyAll, notify (Bl. instancia-clase)


class Cola 				       //  oficia de monitor
{	Celda primero;			//  punteros al primer 
	Celda ultimo;				//  y ltimo elemento
	static int tCon=0;			//  total consumido
	
	Cola()					//  constructor sin argumentos
	{	primero=ultimo=null;} 			
	
	/*	Los mtodos estticos sincronizados  endFila() y contSes()
		implementan bloqueo a nivel clase. Este bloqueo en necesario
		para conseguir imprimir los cuarenta textos que generan 10
		hilos productores y deben ser impresos a razn de 10 p/lnea. */
		
	static synchronized boolean endFila()		//	Fin de fila o rengln
	{if(++tCon%10==0) return true;return false;} 
	
	static synchronized boolean contSes()		//	Contina la sesin ?
	{if(tCon<40) return true;return false;} 
	
	/*	Los mtodos de instancia sincronizados inclUlt() (Incluir ltimo)
		y exclPri() (Excluir primero) implementan bloqueo a nivel instancia. 
		El bloqueo es necesario para conseguir gestionar adecuadamente un 
		nico objeto Cola que recibe textos de 10 hilos productores (Clase 
		WorkStat) y  descarga en 2 hilos consumidores (clase PrintServ) */
		
	public synchronized void inclUlt(Object texto) throws NullPointerException
	{	if(primero==null)
			primero=ultimo=new Celda(texto,null); // usamos constr. con
		else 					//	argumentos de class Celda ...
			ultimo=ultimo.siguiente=new Celda(texto,null);
		notifyAll();    		// 	Ola!!!, tengo trabajo ...
		return;
    }
	public synchronized void exclPri() throws InterruptedException
	{	Object textImp = "**************";	// 	texto a imprimir
		while (primero==null & contSes())
			// 	No tenemos texto en cola, pero la sesin no termin, 
  			wait();			//  esperemos que entre algo ...
    		if (primero!=null)		//	Ya lo hizo !!!
		{	textImp = primero.elemento;
			if(primero.equals(ultimo)) // Slo un texto
				primero=ultimo=null;
			else primero=primero.siguiente;
			System.out.print(textImp);
		}		//  if
	}			//	exclPri
}				//	class

class Celda 
{	Celda siguiente;
	Object elemento;
	Celda(Object elemento) {    //  Constructor
		this.elemento = elemento;
	}
	public Celda(Object elemento, Celda siguiente) { 
		this.elemento= elemento;
		this.siguiente=siguiente;
	}
	public Object getElemento(Object elemento){
		return elemento;
	}
	public void setElemento(Object elemento)
	{	this.elemento=elemento;
	}
	public Celda getSiguiente()
	{	return siguiente;
	}
	public void setSiguiente() 
	{	this.siguiente=siguiente;
	}
}
	
// PRODUCTOR
class WorkStat extends Thread { // Estaciones generan spool
    	private Object elem;
    	private Cola   cola; 
	WorkStat(Cola cola, Object elem) {    //  Constructor
    		this.elem = elem;
		this.cola = cola;
  	 }
	public void run() 
	{	try
		{	cola.inclUlt(elem);	// mtodo de instancia sincronizado
		}	catch (NullPointerException e)
			{	System.err.println("InclUlt():" + e.getMessage()); }
    }		//	run
}		//	class

// CONSUMIDOR
class PrintServ extends Thread { //	Servidores de impresin atienden spool
	private Cola   cola;
	PrintServ(Cola cola) {    //  Constructor
		this.cola = cola;
     }
     public void run() 
	{	try
		{	do
			{
				cola.exclPri();	
				if(Cola.endFila()) System.out.println();
			}
			while(Cola.contSes());
		} 	catch (InterruptedException e)
			{ 	System.err.println("ExclPri():" + e.getMessage());
			}
	} 
}     // class Consumidor

class javaejemplo 
{
	private static int i;
    	public static void main( String args[] ) 
	{	Cola col = new Cola();	//  Una sola vez construyo col
  		for(i=1;i<=4;++i)
		{						//  usuarios generan documentos ...
        		WorkStat   wks0 = new WorkStat(col,"cero    ");
			WorkStat   wks1 = new WorkStat(col,"uno     ");
        		WorkStat   wks2 = new WorkStat(col,"dos     ");
        		WorkStat   wks3 = new WorkStat(col,"tres    ");
        		WorkStat   wks4 = new WorkStat(col,"cuatro ");
        		WorkStat   wks5 = new WorkStat(col,"cinco   ");
		
		//  	primeros 6 usuarios quieren imprimir;
			wks0.start();
 	    		wks1.start();
 	    		wks2.start();
 	    		wks3.start();
 	    		wks4.start();
 	    		wks5.start();
		
 	    	// habilitamos 2 impresoras
 	    		PrintServ  prs1  = new PrintServ(col);
 	    		PrintServ  prs2  = new PrintServ(col);
 	    
 	    	// las arrancamos
 	    		prs1.start();
 	    		prs2.start();
			
 	    	// ms 4 usuarios escribiendo
 	  		WorkStat   wks6 = new WorkStat(col,"seis   ");
			WorkStat   wks7 = new WorkStat(col,"siete  ");
			WorkStat   wks8 = new WorkStat(col,"ocho  ");
			WorkStat   wks9 = new WorkStat(col,"nueve ");
		
		// ms 4 quieren imprimir
			wks6.start();
			wks7.start();
			wks8.start();
			wks9.start();
		}		//	for
    }				// 	main
}				//	class 
