// Author Ing.Tymoschuk, Jorge
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.lang.Integer;
import javax.swing.*;
public class Serie_Ari_144 extends JApplet 
{	JTextField tfa,tfb,tfc; //  Referencias a objetos TextField
   	String msg = " ";      //  mensaje 
	
    SerieControls contr01,contr02,contr03;   //  Controles para avanzar,retroceder 
	                          
    public void init() 
    {	getContentPane().setLayout(new BorderLayout());

		//  Seteando un formato de acuerdo a las posibilidades de java.awt.BorderLayout.
		// Dispondremos de un contenedor que organiza y redimensiona sus componentes para
		// caber en cinco regiones: north, south, east, west y center
	
		getContentPane().add("North" ,contr01 = new SerieControls(tfa,1));
		getContentPane().add("Center",contr02 = new SerieControls(tfb,2));
		getContentPane().add("South" ,contr03 = new SerieControls(tfc,3));
    }

    public void start()
	{	contr01.setEnabled(true);
    	contr02.setEnabled(true);
		contr03.setEnabled(true);
		Thread A = new Thread (new SerieControls(tfa,1));
		Thread B = new Thread (new SerieControls(tfb,2));
		Thread C = new Thread (new SerieControls(tfc,3));
		/*  Estamos generando tres objetos Thread: A, B, C. 
   			Cada uno de estos objetos recibe un objeto SerieControls,
			previamente inicializado por su respectivo constructor con 
			el texto y la razn de la serie pasados como argumento.
			La clase SerieControls implementa runnable y ActionListener */
		A.start();
		B.start();
		C.start();
	}

    public void stop() 
	{	contr01.setEnabled(true);
    	contr02.setEnabled(true);
		contr03.setEnabled(true);
    }

    public void destroy() 
	{
        remove(contr01);
        remove(contr02);
        remove(contr03);
    }

    public void processEvent(AWTEvent e) 
	{	if (e.getID() == Event.WINDOW_DESTROY) 
			{System.exit(0);}
    }

    public void paint(Graphics g) // mtodo invocado "implicitamente" 
    {   g.drawRect(0, 0, getSize().width-1, // por start()
                    getSize().height-1); //  Mtodo de java.awt.Graphics
        g.drawString(msg, 5, 30);       // idem 
    }

    public static void main(String args[]) 
	{	Frame f = new Frame("MultiThread Serie Test");
		Serie_Ari_144	serieAri = new Serie_Ari_144();

		serieAri.init();
		serieAri.start();

		f.add("Center", serieAri);
		f.setSize(400, 200);
		f.show();
    }

}		//  Serie_Ari_144

class SerieControls extends Panel
                  implements Runnable, ActionListener
{ 	JTextField tfd; 
	String s;
	int valAct=0;
    int razon;

	public SerieControls(JTextField txf, int raz)
	{	tfd  = txf; 
		razon=raz;     
		add(tfd = new JTextField("0", 4));
		JButton b = null;
		b = new JButton("Prior");
		b.addActionListener(this);
		add(b);
		b = new JButton("Next");
		b.addActionListener(this);
		add(b);
    }
	
	public void run() 
	{	tfd.setText(s.valueOf(valAct));
	}

    public void actionPerformed(ActionEvent ev) {
	String label = ev.getActionCommand();
    if (label=="Prior")
   		valAct-=razon;
 	else 
	  	valAct+=razon;
		tfd.setText(s.valueOf(valAct));   
    }
}	//  SerieControls


