// Author Ing.Tymoschuk, Jorge
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;
import java.lang.Integer;
import javax.swing.*;

public class Stock extends JApplet {
	static int stock=0;
	PanelProd cPro1=new PanelProd("Productor Uno, listo .......... !!!");
	PanelProd cPro2=new PanelProd("Productor Dos, listo .......... !!!");
	PanelCons cCons=new PanelCons("Consumidor   , listo .......... !!!");
    public void init() {
		getContentPane().setLayout(new GridLayout(3,1));
		getContentPane().add(cPro1);
		getContentPane().add(cPro2);
		getContentPane().add(cCons);
    }

    public void start() {
  		cPro1.setEnabled(true);
		Thread A = new Thread (new Produccion(cPro1));
		A.start();
    	cPro2.setEnabled(true);
    	Thread B = new Thread (new Produccion(cPro2));
    	B.start();
    	cCons.setEnabled(true);
    	Thread C = new Thread (new Consumo(cCons));
    	C.start();  
    }

    public void stop() {
		cPro1.setEnabled(false);
    	cPro2.setEnabled(false);
    	cCons.setEnabled(false);
    }

    public void destroy() {
        remove(cPro1);
    	remove(cPro2);
    	remove(cCons);
    }

    public void processEvent(AWTEvent e) {
        if (e.getID() == Event.WINDOW_DESTROY) {
            System.exit(0);
        }
    }

 	static synchronized void sumStock()
	{	stock++;}

	static synchronized boolean hayStock()
	{	if(stock>2)
		{	stock-=2;
			return true;
		}
		else return false;
	}
}

class Produccion extends Thread { 
	PanelProd pProd;
	int produc=0;
	String s;
	public Produccion(PanelProd pprod){
   		pProd=pprod;
	}
	public void run()  
   	{	
   		Thread me = Thread.currentThread();
   		me.setPriority(Thread.MIN_PRIORITY);
		while (produc<10000)
			{	if(pProd.getStatus()==1)
				{	
					pProd.prd.setText(s.valueOf(++produc));
					Stock.sumStock();
				}
				try 
				{      
			 		sleep(50); //  Dormimos la ejecucin 50 miliseg
					yield();
				}catch( InterruptedException e ) {;} 
			}
   	}
}

class PanelProd extends Panel
                  implements ActionListener {
	JTextField msg,prd;
	String s;
	int status=0; // status: 0, listo;1, produciendo;2, suspendido

	public PanelProd(String hilera){
		try { // Los productores usan camiseta Windows
			javax.swing.UIManager.setLookAndFeel(
			"com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
		} catch (Exception  e) {;}
		msg  = new JTextField(hilera);
		add(msg);
		prd = new JTextField(5);
		add(prd);
		JButton b = null;
		b = new JButton("Producir");
		b.addActionListener(this);
		add(b);
		b = new JButton("Suspender");
		b.addActionListener(this);
		add(b);
    }
	
    public void actionPerformed(ActionEvent ev) {
		String label = ev.getActionCommand();
		if (label=="Producir"){
			status=1;
			msg.setText(s.valueOf("Production running !!")); 
		}	
		else {
			status=2;
			msg.setText(s.valueOf("Production suspended !!")); 
		}
    }
	int getStatus(){return status;}
}

class Consumo extends Thread { 
	PanelCons pCons;
	String s;
	int consum=0;
   	public Consumo(PanelCons pcons){
   		pCons=pcons;
   	}
   	public void run()  
   	{	
   		Thread me = Thread.currentThread();
   		me.setPriority(Thread.MIN_PRIORITY);

		while (consum<10000){
			if(pCons.status==1)
				if(Stock.hayStock())
					pCons.con.setText(s.valueOf(consum+=2));
				else
					pCons.msg.setText("Stock insuficiente ......!!!");
			try 
			{      
			 	sleep(50); //  Dormimos la ejecucin 50 miliseg
				yield();
			}catch( InterruptedException e ) {;} 
		}
   	}
}

class PanelCons extends Panel
                  implements ActionListener {
	JTextField msg,con;
	String s;
	int status=0; // status: 0, listo;1, produciendo;2, suspendido

	public PanelCons(String hilera) {	   
		try { // Los Consumidores prefieren camiseta Solaris ...
			javax.swing.UIManager.setLookAndFeel(
			"com.sun.java.swing.plaf.motif.MotifLookAndFeel");
		} catch (Exception  e) {;}
		msg  = new JTextField(hilera);
		add(msg);
		con = new JTextField(5);
		add(con);
		JButton b = null;
		b = new JButton("Consumir");
		b.addActionListener(this);
		add(b);
		b = new JButton("Suspender");
		b.addActionListener(this);
		add(b);
    }
	
    public void actionPerformed(ActionEvent ev) {
		String label = ev.getActionCommand();
		if (label=="Consumir"){
			status=1;
			msg.setText(s.valueOf("Consumition running !!")); 
		}	
		else {
			status=2;
			msg.setText(s.valueOf("Consumition suspended !!")); 
		}
    }
}


